# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from typing import Set

from sila2.client import SilaClient
from sila2.framework import FullyQualifiedFeatureIdentifier

from .cancelcontroller import (
    CancelControllerClient,
    CancelControllerFeature,
    InvalidCommandExecutionUUID,
    OperationNotSupported,
)
from .connectionconfigurationservice import (
    ConnectionConfigurationServiceClient,
    ConnectionConfigurationServiceFeature,
    InvalidSiLAClient,
)
from .dissolvedoxygencontroller import DissolvedOxygenControllerClient
from .pausecontroller import (
    InvalidCommandExecutionUUID,
    InvalidCommandState,
    OperationNotSupported,
    PauseControllerClient,
    PauseControllerFeature,
)
from .phcontroller import PHControllerClient
from .simulationcontroller import (
    SimulationControllerClient,
    SimulationControllerFeature,
    StartRealModeFailed,
    StartSimulationModeFailed,
)
from .stirrercontroller import StirrerControllerClient
from .temperaturecontroller import MaxTemperatureTooHigh, TemperatureControllerClient, TemperatureControllerFeature
from .turbidityprovider import TurbidityProviderClient


class Client(SilaClient):

    CancelController: CancelControllerClient

    ConnectionConfigurationService: ConnectionConfigurationServiceClient

    DissolvedOxygenController: DissolvedOxygenControllerClient

    PauseController: PauseControllerClient

    SimulationController: SimulationControllerClient

    StirrerController: StirrerControllerClient

    TemperatureController: TemperatureControllerClient

    TurbidityProvider: TurbidityProviderClient

    PHController: PHControllerClient

    _expected_features: Set[FullyQualifiedFeatureIdentifier] = {
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SiLAService/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core.commands/CancelController/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core/ConnectionConfigurationService/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/instruments/DissolvedOxygenController/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core.commands/PauseController/v2"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SimulationController/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/instruments/StirrerController/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/instruments/TemperatureController/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/instruments/TurbidityProvider/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/instruments/PHController/v1"),
    }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self._register_defined_execution_error_class(
            CancelControllerFeature.defined_execution_errors["InvalidCommandExecutionUUID"], InvalidCommandExecutionUUID
        )

        self._register_defined_execution_error_class(
            CancelControllerFeature.defined_execution_errors["OperationNotSupported"], OperationNotSupported
        )

        self._register_defined_execution_error_class(
            ConnectionConfigurationServiceFeature.defined_execution_errors["InvalidSiLAClient"], InvalidSiLAClient
        )

        self._register_defined_execution_error_class(
            PauseControllerFeature.defined_execution_errors["InvalidCommandExecutionUUID"], InvalidCommandExecutionUUID
        )

        self._register_defined_execution_error_class(
            PauseControllerFeature.defined_execution_errors["InvalidCommandState"], InvalidCommandState
        )

        self._register_defined_execution_error_class(
            PauseControllerFeature.defined_execution_errors["OperationNotSupported"], OperationNotSupported
        )

        self._register_defined_execution_error_class(
            SimulationControllerFeature.defined_execution_errors["StartSimulationModeFailed"], StartSimulationModeFailed
        )

        self._register_defined_execution_error_class(
            SimulationControllerFeature.defined_execution_errors["StartRealModeFailed"], StartRealModeFailed
        )

        self._register_defined_execution_error_class(
            TemperatureControllerFeature.defined_execution_errors["MaxTemperatureTooHigh"], MaxTemperatureTooHigh
        )
